#!/usr/bin/perl

# static char sccsid[] = "@(#)88 1.7 src/ll/config_editor/cgi-bin/preempt_or_start_class_insert.pl, ll.config, ll_rrur2, rrur21042a 1/12/10 03:38:29\n";

use strict;
use lib "/var/www/ll/cgi-bin";
use LLUtil;
use DBI;

# table=TLLS_CFGPreemptClass&incoming_class=rt&all_or_enough=enough&method=vc&outgoing_class=a b&clusterID=2
# table=TLLS_CFGPreemptStartClass&incoming_class=aa&running_class=yy&number_of_tasks=43&clusterID=2
my $query = $ENV{QUERY_STRING};
$query = unescape($query);
debug_log($query);

# create the db connection
my $dbh = get_dbh(0);
if(!defined($dbh))
{
	error_and_exit(DBI->errstr);
}

# parse input string
my @pairs = split('&',$query);
my $table = ();
my %values = ();
foreach my $pair (@pairs)
{
	$_ = $pair;
	if(/(.+)=(.+)/)
	{
		if($1 eq "table") { $table = $2; }
		else
		{
			$values{$1} = $2;
		}
	}
}

my $return_id;
my $sql_str;

if($table eq "TLLS_CFGPreemptClass")
{
	# data checking
	{
		$sql_str = "select * from ".$table." where clusterID=".$values{"clusterID"};
		my $keyword_string = get_default_keyword_str($dbh,$sql_str,$table);
		my @columns = (-1,$values{"clusterID"},$values{"incoming_class"},$values{"all_or_enough"},$values{"method"},$values{"outgoing_class"});
		$keyword_string .= format_keywords($dbh,\@columns, $table);
		debug_log("preempt_or_start_class_insert.pl - ".$keyword_string);

		my $stanza_name = get_value_by_id($dbh,"name","clusterID","TLL_Cluster",$values{"clusterID"});
		check_data($dbh,$table,undef,$keyword_string,$stanza_name,"preempt_add");
	}

	# add new record into TLLS_CFGPreemptClass
	$sql_str="insert into ".$table." set clusterID=".$values{"clusterID"}.",incoming_class='".$values{"incoming_class"}."',all_or_enough='".$values{"all_or_enough"}."',method='".$values{"method"}."'";
	debug_log($sql_str);
	if(!defined($dbh->do($sql_str)))
	{
		error_and_exit($dbh->errstr);
	}

	$return_id = $dbh->last_insert_id(undef,undef,undef,undef);

	# add out going classes into TLLS_CFGPreemptClassOutgoing
	my @outgoing_classes = split(' ',$values{"outgoing_class"});
	foreach my $outgoing (@outgoing_classes)
	{
		if(length($outgoing) > 0)
		{
			$sql_str="insert into TLLS_CFGPreemptClassOutgoing set preemptID=".$return_id.", outgoing_class='".$outgoing."'";
			if(!defined($dbh->do($sql_str)))
			{
				error_and_exit($dbh->errstr);
			}
		}
	}
}
elsif($table eq "TLLS_CFGPreemptStartClass")
{
	# find out if the record exists in TLLS_CFGPreemptStartClass
	$sql_str="select startID from ".$table." where clusterID=".$values{"clusterID"}." and incoming_class='".$values{"incoming_class"}."'";
	my $sth=$dbh->prepare($sql_str);
	if(!defined($sth->execute()))
	{
		error_and_exit($dbh->errstr);
	}
	my($id);
	$sth->bind_columns(undef,\$id);
	my $existed = 0;
	if($sth->fetch())
	{
		$return_id = $id;
		$existed = 1;
	}

	# data checking
	{
		my $keyword_string = "";
		if($existed == 0)
		{
			$sql_str = "select * from ".$table." where clusterID=".$values{"clusterID"};
			$keyword_string = get_default_keyword_str($dbh,$sql_str,$table);
			my @columns = (-1,$values{"clusterID"},$values{"incoming_class"},$values{"running_class"},$values{"number_of_tasks"});
			$keyword_string .= format_keywords($dbh,\@columns, $table);
			debug_log("preempt_or_start_class_insert.pl, start class does not exist, keyword string - ".$keyword_string);
		}
		else
		{
			# get the keyword string from DB, except for the existed incoming_class.
			$sql_str = "select * from ".$table." where clusterID=".$values{"clusterID"}." && startID != ".$return_id;
			$keyword_string = get_default_keyword_str($dbh,$sql_str,$table);
			debug_log("preempt_or_start_class_insert.pl, start class exists, keyword string - ".$keyword_string);

			# if the start class with the input incoming_class exists,
			# we should get its running classes from DB, and put them together with the newly input running class.
			$sql_str = "select * from TLLS_CFGPreemptStartClassRunningTasks where startID=".$return_id;
			$sth = $dbh->prepare($sql_str);
			my $current_keyword_string = "START_CLASS[".$values{"incoming_class"}."] = ";
			# running class from DB
			if(!defined($sth->execute()))
			{
				error_and_exit($dbh->errstr);
			}
			else
			{
				my $ary_ref;
				while($ary_ref = $sth->fetchrow_arrayref)
				{
					$current_keyword_string .= "(".$ary_ref->[1]."<".$ary_ref->[2].") && ";
				}
			}
			# newly input running class 
			$keyword_string .= $current_keyword_string."(".$values{"running_class"}."<".$values{"number_of_tasks"}.")";
		}
		my $stanza_name = get_value_by_id($dbh,"name","clusterID","TLL_Cluster",$values{"clusterID"});
		check_data($dbh,$table,undef,$keyword_string,$stanza_name,"start_add");
	}
	
	# if no record for this clusterID and incoming_class, insert a new one.
	if($existed == 0)
	{
		
		$sql_str="insert into ".$table." set clusterID=".$values{"clusterID"}.",incoming_class='".$values{"incoming_class"}."'";
		if(!defined($dbh->do($sql_str)))
		{
			error_and_exit($dbh->errstr);
		}

		$return_id = $dbh->last_insert_id(undef,undef,undef,undef);
	}

	# insert a new record into TLLS_CFGPreemptStartClassRunningTasks
	$sql_str="insert into TLLS_CFGPreemptStartClassRunningTasks set startID=".$return_id.",running_class='".$values{"running_class"}."',number_of_tasks='".$values{"number_of_tasks"}."'";
	if(!defined($dbh->do($sql_str)))
	{
		error_and_exit($dbh->errstr);
	}
	$sth->finish();
}
else
{
	error_and_exit("Error: unknown table - ".$table);
}

$dbh->disconnect();

print LLUtil::OUTPUT_HEADER."({rs:'OK',id:'".$return_id."'})";

