#!/usr/bin/perl

# static char sccsid[] = "@(#)21 1.9 src/ll/config_editor/cgi-bin/pull_down_on_change_for_cluster.pl, ll.config, ll_rrur2, rrur21042a 1/2/10 03:57:35\n";

use strict;
use lib "/var/www/ll/cgi-bin";
use LLUtil;
use DBI;

my ($mysql_host, $mysql_user, $mysql_pass, $mysql_db) = get_db_info(0);

my $query = $ENV{QUERY_STRING};
$query = unescape($query);

$_ = $query;
if(/panel=(.+)&id=(\d+)/)
{
	my $json_str = LLUtil::OUTPUT_HEADER."[";

	my $dbh = DBI->connect("DBI:mysql:database=$mysql_db;host=$mysql_host",$mysql_user,$mysql_pass);
	if(!defined($dbh))
	{
		$json_str = LLUtil::OUTPUT_HEADER."Error:".DBI->errstr;
		print $json_str;		
		exit 1;
	}
	my $panel_name = $1;
	my $cluster_id = $2;
	my $sql_str;
	my $default_name;

	if($panel_name eq "tab_panel_users")
	{
		$default_name = "New user";

		my $default_user_id = get_default_id($dbh,"userID","name","TLLS_CFGUser",$cluster_id);
		
		# Get default values
		if(defined($default_user_id))
		{
			$json_str .= get_default_json_str($dbh,"tab_panel_users","userID",$default_user_id,0);
		}		
		
		$sql_str="select userID,name from TLLS_CFGUser where clusterID=".$cluster_id;
	}
	elsif($panel_name eq "tab_panel_groups")
	{
		$default_name = "New group";

		my $default_group_id = get_default_id($dbh,"groupID","name","TLLS_CFGGroup",$cluster_id);
		
		# Get default values
		if(defined($default_group_id))
		{
			$json_str .= get_default_json_str($dbh,"tab_panel_groups","groupID",$default_group_id,0);
		}		
		
		$sql_str="select groupID,name from TLLS_CFGGroup where clusterID=".$cluster_id;
	}
	elsif($panel_name eq "tab_panel_classes")
	{
		$default_name = "New class";

		my $default_class_id = get_default_id($dbh,"classID","name","TLLS_CFGClass",$cluster_id);
		
		# Get default values
		if(defined($default_class_id))
		{
			$json_str .= get_default_json_str($dbh,"tab_panel_classes","classID",$default_class_id,0);
		}		
		
		$sql_str="select classID,name from TLLS_CFGClass where clusterID=".$cluster_id;
	}
	elsif($panel_name eq "tab_panel_machine_groups")
	{
		$default_name = "New machine groups";

		my $default_mg_id = get_default_id($dbh,"mgID","name","TLL_MachineGroup",$cluster_id);
		
		# Get default values
		if(defined($default_mg_id))
		{
			$json_str .= get_default_json_str($dbh,"tab_panel_machine_groups","mgID",$default_mg_id,0);
		}		
		
		$sql_str="select mgID,name from TLL_MachineGroup where clusterID=".$cluster_id;
	}
	elsif($panel_name eq "tab_panel_region")
	{
		$default_name = "New region";

		my $default_region_id = get_default_id($dbh,"regionID","name","TLLR_CFGRegion",$cluster_id);
		
		# Get default values
		if(defined($default_region_id))
		{
			$json_str .= get_default_json_str($dbh,"tab_panel_region","regionID",$default_region_id,0);
		}		
		
		$sql_str="select regionID,name from TLLR_CFGRegion where clusterID=".$cluster_id;
	}
	elsif($panel_name eq "tab_panel_machines")
	{
		$default_name = "New machine";

		my $default_node_id = get_default_id($dbh,"nodeID","hostname","TLL_Nodelist",$cluster_id);
		
		# Get default values
		if(defined($default_node_id))
		{
			$json_str .= get_default_json_str($dbh,"tab_panel_machines","nodeID",$default_node_id,0);
		}		
		
		$sql_str="select nodeID,hostname from TLL_Nodelist where clusterID=".$cluster_id;
	}
	else
	{
		$json_str = LLUtil::OUTPUT_HEADER."Error: unknown panel name - ".$panel_name;
		print $json_str;		
		exit 1;
	}

	debug_log($sql_str);
	
	my $sth=$dbh->prepare($sql_str);
	if(!defined($sth->execute()))
	{
		$json_str = LLUtil::OUTPUT_HEADER."Error:".$dbh->errstr;
		print $json_str;		
		exit 1;
	}

	my($id,$name);
	$sth->bind_columns(undef,\$id,\$name);

	$json_str .= "{type:'pull_down',pairs:[";
	$json_str .= "{id:'0',name:'".$default_name."'},";
	while($sth->fetch())
	{
		$json_str .= "{id:'".$id."',name:'".$name."'},";
	}
	
	$json_str =~ s/,$//g;
	$json_str .= "]}";
	$json_str .= "]";
	if(defined($sth)) {$sth->finish();}
	print $json_str;
	$dbh->disconnect();

}
